// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package bob

import (
	"context"
	"database/sql"
	"errors"
	"fmt"

	"github.com/aarondl/opt/omit"
	"github.com/google/uuid"
	"github.com/stephenafamo/bob"
	"github.com/stephenafamo/bob/clause"
	"github.com/stephenafamo/bob/dialect/psql"
	"github.com/stephenafamo/bob/dialect/psql/dialect"
	"github.com/stephenafamo/bob/dialect/psql/im"
	"github.com/stephenafamo/bob/dialect/psql/sm"
	"github.com/stephenafamo/bob/dialect/psql/um"
	"github.com/stephenafamo/bob/mods"
)

// User is an object representing the database table.
type User struct {
	UserID       uuid.UUID `db:"user_id,pk" `
	Username     string    `db:"username" `
	Passwordhash string    `db:"passwordhash" `

	R userR `db:"-" `
}

// UserSlice is an alias for a slice of pointers to User.
// This should almost always be used instead of []*User.
type UserSlice []*User

// Users contains methods to work with the users table
var Users = psql.NewTablex[*User, UserSlice, *UserSetter]("", "users")

// UsersQuery is a query on the users table
type UsersQuery = *psql.ViewQuery[*User, UserSlice]

// UsersStmt is a prepared statment on users
type UsersStmt = bob.QueryStmt[*User, UserSlice]

// userR is where relationships are stored.
type userR struct {
	Watchlists WatchlistSlice // watchlist.watchlist_user_id_fkey
}

// UserSetter is used for insert/upsert/update operations
// All values are optional, and do not have to be set
// Generated columns are not included
type UserSetter struct {
	UserID       omit.Val[uuid.UUID] `db:"user_id,pk"`
	Username     omit.Val[string]    `db:"username"`
	Passwordhash omit.Val[string]    `db:"passwordhash"`
}

func (s UserSetter) SetColumns() []string {
	vals := make([]string, 0, 3)
	if !s.UserID.IsUnset() {
		vals = append(vals, "user_id")
	}

	if !s.Username.IsUnset() {
		vals = append(vals, "username")
	}

	if !s.Passwordhash.IsUnset() {
		vals = append(vals, "passwordhash")
	}

	return vals
}

func (s UserSetter) Overwrite(t *User) {
	if !s.UserID.IsUnset() {
		t.UserID, _ = s.UserID.Get()
	}
	if !s.Username.IsUnset() {
		t.Username, _ = s.Username.Get()
	}
	if !s.Passwordhash.IsUnset() {
		t.Passwordhash, _ = s.Passwordhash.Get()
	}
}

func (s UserSetter) Apply(q *dialect.UpdateQuery) {
	if !s.UserID.IsUnset() {
		um.Set("user_id").ToArg(s.UserID).Apply(q)
	}
	if !s.Username.IsUnset() {
		um.Set("username").ToArg(s.Username).Apply(q)
	}
	if !s.Passwordhash.IsUnset() {
		um.Set("passwordhash").ToArg(s.Passwordhash).Apply(q)
	}
}

func (s UserSetter) Insert() bob.Mod[*dialect.InsertQuery] {
	vals := make([]bob.Expression, 3)
	if s.UserID.IsUnset() {
		vals[0] = psql.Raw("DEFAULT")
	} else {
		vals[0] = psql.Arg(s.UserID)
	}

	if s.Username.IsUnset() {
		vals[1] = psql.Raw("DEFAULT")
	} else {
		vals[1] = psql.Arg(s.Username)
	}

	if s.Passwordhash.IsUnset() {
		vals[2] = psql.Raw("DEFAULT")
	} else {
		vals[2] = psql.Arg(s.Passwordhash)
	}

	return im.Values(vals...)
}

type userColumnNames struct {
	UserID       string
	Username     string
	Passwordhash string
}

type userRelationshipJoins[Q dialect.Joinable] struct {
	Watchlists bob.Mod[Q]
}

func builduserRelationshipJoins[Q dialect.Joinable](ctx context.Context, typ string) userRelationshipJoins[Q] {
	return userRelationshipJoins[Q]{
		Watchlists: usersJoinWatchlists[Q](ctx, typ),
	}
}

func usersJoin[Q dialect.Joinable](ctx context.Context) joinSet[userRelationshipJoins[Q]] {
	return joinSet[userRelationshipJoins[Q]]{
		InnerJoin: builduserRelationshipJoins[Q](ctx, clause.InnerJoin),
		LeftJoin:  builduserRelationshipJoins[Q](ctx, clause.LeftJoin),
		RightJoin: builduserRelationshipJoins[Q](ctx, clause.RightJoin),
	}
}

var UserColumns = struct {
	UserID       psql.Expression
	Username     psql.Expression
	Passwordhash psql.Expression
}{
	UserID:       psql.Quote("users", "user_id"),
	Username:     psql.Quote("users", "username"),
	Passwordhash: psql.Quote("users", "passwordhash"),
}

type userWhere[Q psql.Filterable] struct {
	UserID       psql.WhereMod[Q, uuid.UUID]
	Username     psql.WhereMod[Q, string]
	Passwordhash psql.WhereMod[Q, string]
}

func UserWhere[Q psql.Filterable]() userWhere[Q] {
	return userWhere[Q]{
		UserID:       psql.Where[Q, uuid.UUID](UserColumns.UserID),
		Username:     psql.Where[Q, string](UserColumns.Username),
		Passwordhash: psql.Where[Q, string](UserColumns.Passwordhash),
	}
}

// FindUser retrieves a single record by primary key
// If cols is empty Find will return all columns.
func FindUser(ctx context.Context, exec bob.Executor, UserIDPK uuid.UUID, cols ...string) (*User, error) {
	if len(cols) == 0 {
		return Users.Query(
			ctx, exec,
			SelectWhere.Users.UserID.EQ(UserIDPK),
		).One()
	}

	return Users.Query(
		ctx, exec,
		SelectWhere.Users.UserID.EQ(UserIDPK),
		sm.Columns(Users.Columns().Only(cols...)),
	).One()
}

// UserExists checks the presence of a single record by primary key
func UserExists(ctx context.Context, exec bob.Executor, UserIDPK uuid.UUID) (bool, error) {
	return Users.Query(
		ctx, exec,
		SelectWhere.Users.UserID.EQ(UserIDPK),
	).Exists()
}

// PrimaryKeyVals returns the primary key values of the User
func (o *User) PrimaryKeyVals() bob.Expression {
	return psql.Arg(o.UserID)
}

// Update uses an executor to update the User
func (o *User) Update(ctx context.Context, exec bob.Executor, s *UserSetter) error {
	return Users.Update(ctx, exec, s, o)
}

// Delete deletes a single User record with an executor
func (o *User) Delete(ctx context.Context, exec bob.Executor) error {
	return Users.Delete(ctx, exec, o)
}

// Reload refreshes the User using the executor
func (o *User) Reload(ctx context.Context, exec bob.Executor) error {
	o2, err := Users.Query(
		ctx, exec,
		SelectWhere.Users.UserID.EQ(o.UserID),
	).One()
	if err != nil {
		return err
	}
	o2.R = o.R
	*o = *o2

	return nil
}

func (o UserSlice) UpdateAll(ctx context.Context, exec bob.Executor, vals UserSetter) error {
	return Users.Update(ctx, exec, &vals, o...)
}

func (o UserSlice) DeleteAll(ctx context.Context, exec bob.Executor) error {
	return Users.Delete(ctx, exec, o...)
}

func (o UserSlice) ReloadAll(ctx context.Context, exec bob.Executor) error {
	var mods []bob.Mod[*dialect.SelectQuery]

	UserIDPK := make([]uuid.UUID, len(o))

	for i, o := range o {
		UserIDPK[i] = o.UserID
	}

	mods = append(mods,
		SelectWhere.Users.UserID.In(UserIDPK...),
	)

	o2, err := Users.Query(ctx, exec, mods...).All()
	if err != nil {
		return err
	}

	for _, old := range o {
		for _, new := range o2 {
			if new.UserID != old.UserID {
				continue
			}
			new.R = old.R
			*old = *new
			break
		}
	}

	return nil
}

func usersJoinWatchlists[Q dialect.Joinable](ctx context.Context, typ string) bob.Mod[Q] {
	return mods.QueryMods[Q]{
		dialect.Join[Q](typ, Watchlists.Name(ctx)).On(
			WatchlistColumns.UserID.EQ(UserColumns.UserID),
		),
	}
}

// Watchlists starts a query for related objects on watchlist
func (o *User) Watchlists(ctx context.Context, exec bob.Executor, mods ...bob.Mod[*dialect.SelectQuery]) WatchlistsQuery {
	return Watchlists.Query(ctx, exec, append(mods,
		sm.Where(WatchlistColumns.UserID.EQ(psql.Arg(o.UserID))),
	)...)
}

func (os UserSlice) Watchlists(ctx context.Context, exec bob.Executor, mods ...bob.Mod[*dialect.SelectQuery]) WatchlistsQuery {
	PKArgs := make([]bob.Expression, len(os))
	for i, o := range os {
		PKArgs[i] = psql.ArgGroup(o.UserID)
	}

	return Watchlists.Query(ctx, exec, append(mods,
		sm.Where(psql.Group(WatchlistColumns.UserID).In(PKArgs...)),
	)...)
}

func (o *User) Preload(name string, retrieved any) error {
	if o == nil {
		return nil
	}

	switch name {
	case "Watchlists":
		rels, ok := retrieved.(WatchlistSlice)
		if !ok {
			return fmt.Errorf("user cannot load %T as %q", retrieved, name)
		}

		o.R.Watchlists = rels

		for _, rel := range rels {
			if rel != nil {
				rel.R.User = o
			}
		}
		return nil
	default:
		return fmt.Errorf("user has no relationship %q", name)
	}
}

func ThenLoadUserWatchlists(queryMods ...bob.Mod[*dialect.SelectQuery]) psql.Loader {
	return psql.Loader(func(ctx context.Context, exec bob.Executor, retrieved any) error {
		loader, isLoader := retrieved.(interface {
			LoadUserWatchlists(context.Context, bob.Executor, ...bob.Mod[*dialect.SelectQuery]) error
		})
		if !isLoader {
			return fmt.Errorf("object %T cannot load UserWatchlists", retrieved)
		}

		err := loader.LoadUserWatchlists(ctx, exec, queryMods...)

		// Don't cause an issue due to missing relationships
		if errors.Is(err, sql.ErrNoRows) {
			return nil
		}

		return err
	})
}

// LoadUserWatchlists loads the user's Watchlists into the .R struct
func (o *User) LoadUserWatchlists(ctx context.Context, exec bob.Executor, mods ...bob.Mod[*dialect.SelectQuery]) error {
	if o == nil {
		return nil
	}

	// Reset the relationship
	o.R.Watchlists = nil

	related, err := o.Watchlists(ctx, exec, mods...).All()
	if err != nil {
		return err
	}

	for _, rel := range related {
		rel.R.User = o
	}

	o.R.Watchlists = related
	return nil
}

// LoadUserWatchlists loads the user's Watchlists into the .R struct
func (os UserSlice) LoadUserWatchlists(ctx context.Context, exec bob.Executor, mods ...bob.Mod[*dialect.SelectQuery]) error {
	if len(os) == 0 {
		return nil
	}

	watchlists, err := os.Watchlists(ctx, exec, mods...).All()
	if err != nil {
		return err
	}

	for _, o := range os {
		o.R.Watchlists = nil
	}

	for _, o := range os {
		for _, rel := range watchlists {
			if o.UserID != rel.UserID {
				continue
			}

			rel.R.User = o

			o.R.Watchlists = append(o.R.Watchlists, rel)
		}
	}

	return nil
}

func insertUserWatchlists0(ctx context.Context, exec bob.Executor, watchlists1 []*WatchlistSetter, user0 *User) (WatchlistSlice, error) {
	for _, watchlist1 := range watchlists1 {
		watchlist1.UserID = omit.From(user0.UserID)
	}

	ret, err := Watchlists.InsertMany(ctx, exec, watchlists1...)
	if err != nil {
		return ret, fmt.Errorf("insertUserWatchlists0: %w", err)
	}

	return ret, nil
}

func attachUserWatchlists0(ctx context.Context, exec bob.Executor, watchlists1 WatchlistSlice, user0 *User) error {
	setter := &WatchlistSetter{
		UserID: omit.From(user0.UserID),
	}

	err := Watchlists.Update(ctx, exec, setter, watchlists1...)
	if err != nil {
		return fmt.Errorf("attachUserWatchlists0: %w", err)
	}

	return nil
}

func (user0 *User) InsertWatchlists(ctx context.Context, exec bob.Executor, related ...*WatchlistSetter) error {
	if len(related) == 0 {
		return nil
	}

	watchlist1, err := insertUserWatchlists0(ctx, exec, related, user0)
	if err != nil {
		return err
	}

	user0.R.Watchlists = append(user0.R.Watchlists, watchlist1...)

	for _, rel := range watchlist1 {
		rel.R.User = user0
	}

	return nil
}

func (user0 *User) AttachWatchlists(ctx context.Context, exec bob.Executor, related ...*Watchlist) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	watchlist1 := WatchlistSlice(related)

	err = attachUserWatchlists0(ctx, exec, watchlist1, user0)
	if err != nil {
		return err
	}

	user0.R.Watchlists = append(user0.R.Watchlists, watchlist1...)

	for _, rel := range related {
		rel.R.User = user0
	}

	return nil
}
